#!/bin/bash

WordList="$HOME/word.rwd"			#单词表输入路径 （千万不要让此文件无-end-标示，否则会后悔）
Blank="$HOME/Blank.wav"				#空白

outmp3="$HOME/桌面/English.mp3"			#合成后MP3输出路径
Lrc="$HOME/桌面/English.lrc"			#Lrc歌词输出路径

#==========================以下不明白就不要改==================================
Lrcutf8="/tmp/Englishutf8.lrc"		#中间文件输出路径	
config="/tmp/comp.sh"

OutputRate=44100						#sample rate

wrpTTSDir="/usr/share/WyabdcRealPeopleTTS/"			#真人语音库路径
orpTTSDir="/usr/share/OtdRealPeopleTTS/"

outtmp1="/tmp/study/out1.wav"
outtmp2="/tmp/study/out2.wav"
tmp="/tmp/study/"						#缓存路径&&创建

if [ -w $tmp ]
then clear
else
mkdir $tmp
fi

mv $Blank `dirname $Blank`/w`basename $Blank`
sox `dirname $Blank`/w`basename $Blank` -r $OutputRate $Blank	#间隔sample rate 修改

#=============================================================================

WavManipulate ()						#修改wav rate，设置文件表
{
	#=====================输入文件，输出文件名的部分================
		wpath="$wrpTTSDir${English:0:1}/$English.wav"
		opath="$orpTTSDir${English:0:1}/$English.wav"
		outpath="${tmp}${English}_"
	#====================文件存在验证,生成,处理========================
		if [ -r "$wpath" ]
		then
			flag=W
			sox "$wpath" -r $OutputRate -c 1 "${outpath}W.wav"
			if [ -r "$opath" ]
			then
				flag="${flag}O"
				sox "$opath" -r $OutputRate -c 1 "${outpath}O.wav"
			#=====================文件名写入==================================
			filelist="$filelist	\"${outpath}W.wav\"	\"$Blank\"	\"${outpath}O.wav\"	\"$Blank\""
			else
			filelist="$filelist	\"${outpath}W.wav\"	\"$Blank\"	\"${outpath}W.wav\"	\"$Blank\""
			fi
		else	if [ -r "$opath" ]
			then
				flag=O
				sox "$opath" -r $OutputRate -c 1 "${outpath}O.wav"
				#=====================文件名写入==================================
				filelist="$filelist	\"${outpath}O.wav\"	\"$Blank\"	\"${outpath}O.wav\"	\"$Blank\""
				
			else
			flag=C
			swift "$English" -o "${outpath}${flag}-t.wav"
			sox "${outpath}${flag}-t.wav" -r $OutputRate -c 1 "$outpath$flag.wav"
			#=====================文件名写入==================================
			filelist="$filelist	\"$outpath$flag.wav\"	\"$Blank\"	\"$outpath$flag.wav\"	\"$Blank\""
			fi
		fi
}

LrcManipulate()
{
									#秒数
	  #===========================时长计算，Lrc写入============
		if [ "$flag" = "WO" ]
		then
			#=====================时长计算===================================
	 		time1=`mplayer -ao null -frames 0 -identify "${outpath}O.wav" 2>/dev/null |grep ID_LENGTH`
			time2=`mplayer -ao null -frames 0 -identify "${outpath}W.wav" 2>/dev/null |grep ID_LENGTH`
			time1=${time1##ID_LENGTH=}
			time2=${time2##ID_LENGTH=}
			time1=${time1%%.*}${time1##*.}
			time2=${time2%%.*}${time2##*.}
			time1=${time1#0}
			time2=${time2#0}
			#=====================Lrc写入====================================
			echo  "[$(($TotalTime/6000)):$(($TotalTime/100%60)).$(($TotalTime%100))]${English}-${Chinese}">>$Lrcutf8

			TotalTime=$(($TotalTime+$time1+$time2+600))
		else
			#=====================时长计算===================================
			time=`mplayer -ao null -frames 0 -identify "$outpath$flag.wav" 2>/dev/null |grep ID_LENGTH`
			time=${time##ID_LENGTH=}
			time=${time%%.*}${time##*.}
			time=${time#0}
			#=====================Lrc写入====================================
			echo  "[$(($TotalTime/6000)):$(($TotalTime/100%60)).$(($TotalTime%100))]${English}-${Chinese}">>$Lrcutf8
			TotalTime="$(($TotalTime+$time+600+$time))"

		fi
}
	
#main()	#入口

filelist=\"$Blank\"				#空白wav

#=======================ID-tag=====================================
echo "[ar:w/orpTTS]">$Lrcutf8
echo "[ti:wordlist]">>$Lrcutf8
echo "[al:For human being]">>$Lrcutf8
echo "[by:SuperReciteWord]">>$Lrcutf8
echo "[offset:0]">>$Lrcutf8
echo "[0:0.0]maker XXC">>$Lrcutf8
echo "[0:1.0]感谢你的使用,联系方式:Email:x007007007@gmail.com">>$Lrcutf8
#=============================写入Lrc的标识标签======================

TotalTime=300

#=================================================================
LineNo=1

while [ "$flag" != "end" ]
do
	No=1
	while [ $No -le 7 ]
	do
	if [ -n "$Data" ]
	then
		WavManipulate
		LrcManipulate
	fi
	echo "English:$English	Chinese:$Chinese"	lineNo=$LineNo

	Data=`head -n $LineNo $WordList|tail -n 1`

	if [ "$Data" = '-end-' ]
	then
	No=8
	flag="end"
	echo "读取发现结束标志-end-"
	sleep 1
	else
	English=${Data%%<->*}
	Chinese=${Data##*<->}
	LineNo=$(($LineNo+1)) 
	No=$(($No+1))
	fi
	done

Sox=`echo  "sox $filelist	$outtmp1"`	#合成
echo '#!/bin/bash'>$config
echo $Sox >>$config
bash $config
mv $outtmp1 $outtmp2
filelist="\"$outtmp2\""
	#======================再次计算时间==============================
		TotalTime=`mplayer -ao null -frames 0 -identify "$outtmp2" 2>/dev/null |grep ID_LENGTH`
		TotalTime=${TotalTime##ID_LENGTH=}
		TotalTime=${TotalTime%%.*}${TotalTime##*.}
		TotalTime=${TotalTime#0}
	echo $TotalTime
done
#echo "离开until"

#end

echo -n "">$Lrc
iconv -f utf-8 -t gb2312 "$Lrcutf8">>$Lrc
echo  "转化MP3"
lame --quiet $outtmp2 $outmp3
echo  "清理中间文件"
rm "$Lrcutf8"
rm $outtmp2
rm -r $tmp
rm $config
rm `dirname $Blank`/w`basename $Blank`
clear
